// synthesisSuccessful = True
// numberOfExamplesUsed = 3
// numberOfExamplesProvided = 3
// computationTime = 2.2122419
// grammarName = XML
// maxNumberOfBranches = 1

using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using _ = TestDSLs.XMLTransformImpl;

namespace lasyOutput
{
	public static class LasyOutput
	{
		public static XElement GroupBooks(XElement oldXml)
		{
			unchecked
			{
				return _.CreateNode("report", new XAttribute[0], _.MapStringToXElement(a0 => (a1 => (BooksForAuthor(a0, a1)))(oldXml), _.Unique(_.MapXElementToString(a0 => (a1 => (_.GetAttributeValue(a0, a1)))("author"), _.ChildElements(oldXml)))));
			}
		}
		
		public static XElement BooksForAuthor(XElement oldXml, string author)
		{
			unchecked
			{
				return _.CreateNode("author", _.Attributes(_.Attribute("name", author)), _.MapStringToXElement(a0 => (a1 => (a2 => (_.CreateNode(a0, a1, a2))))("title")(_.Attributes()), _.MapXElementToString(a0 => (a1 => (_.GetAttributeValue(a0, a1)))("title"), _.DescendantsWithAttributeValue("author", _.InAttrValue(author), oldXml))));
			}
		}
	}
}